<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2004 Alexander Langer <alex@big.endian.de>
*  (c) 2003 Juraj Benadik (gastan@gastan.sk)
*  (c) 2002 Mads Jensen (mads.jensen@afs.org)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'Extended Calendar' for the 'calendar' extension.
 *
 * @author	Alexander Langer <alex@big.endian.de>
 * @author	Juraj Benadik (GASTAN)
 * @author	Mads-Peter Brunn Jensen
 */

require_once(PATH_tslib."class.tslib_pibase.php");

/* This corrensponds to the values you can set in the backend */
define("CALENDAR_VIEW_MONTH", 0);
define("CALENDAR_VIEW_WEEK", 1);
define("CALENDAR_VIEW_DAY", 2);
define("CALENDAR_VIEW_QUICK", 3);
define("CALENDAR_VIEW_QUICK", 4);
define("CALENDAR_VIEW_EVENT", 5);


class tx_calendar_pi1 extends tslib_pibase {
	var $prefixId = "tx_calendar_pi1";		// Same as class name
	var $scriptRelPath = "pi1/class.tx_calendar_pi1.php";	// Path to this script relative to the extension dir.
	var $extKey = "calendar";	// The extension key.

	var $dbTable = "tx_calendar_item";
	var $allowCaching = 1;
	
	function initdefaults($content, $conf) {
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->internal["currentTable"] = $this->dbTable;

		// Do we have a current view timestamp already? if not, use todays
		if (!$this -> getTime()) {
			$this->setTime($this->getTodayTime());
		}

		if ($this->piVars['showUid'] && $this->getCurrentView() != CALENDAR_VIEW_EVENT)
			unset($this->piVars['showUid']);

		// same for view, use default view as given in Backend
		if (!$this->getCurrentView()) {
			$this->setCurrentView($this->cObj->data["tx_calendar_whattoshow"]);
		}

		// XXX should better use getTreeList()
		$this->setPidlist($this->cObj->data["pages"]);

		##	$this -> config["pid_list"] = $this -> config["pid_list"] ? implode(t3lib_div :: intExplode(",", $this -> config["pid_list"]), ",") : $GLOBALS["TSFE"] -> id;
		##	list ($pid) = explode(",", $this -> config["pid_list"]);

		$this->loadCategories();
	}

	/**
	 * [Put your description here]
	 */
	function main($content,$conf)	{
		$this->initdefaults($content, $conf);

		$content .= $this -> pi_getEditPanel();

		switch ($this->getCurrentView()) {
			case CALENDAR_VIEW_WEEK:
				$content.= $this->displayWeek();
				break;
			case CALENDAR_VIEW_DAY:
				$content.= $this->displayDay();
				break;
			case CALENDAR_VIEW_EVENT:
				$content .= $this->displayEvent($content,$conf);
				break;
			case CALENDAR_VIEW_QUICK:
				$content.= $this->displayQuickview();
				break;
			case CALENDAR_VIEW_MONTH:
			default :
				$content.= $this->displayMonth();
				break;
		}
		return $this->pi_wrapInBaseClass($content);
	}


	/**
	 * Loading the categories into an internal array, $this->categories
	 */
	function loadCategories() {
		$query = $this->pi_categoriesUsed("tx_calendar_cat");
		$res = mysql(TYPO3_db, $query);
		if (mysql_errno()) {
			print "<pre>".$query;
			die(mysql_error());
		}

		$this->categories = array();

		while ($row = mysql_fetch_assoc($res)) {
			$this->categories[$row["uid"]] = $row;
		}
	}
	/**
	 * (Maybe bad name for this function) construct SQL-query for
	 * categories.
	 */
	function pi_categoriesUsed($cat_table) {
		// XXX should be modified to return only categories that are really in use.  
		$pidList = $this->getPidlist();
		$query = "SELECT ".$cat_table.".* "."\n"."FROM $cat_table WHERE $cat_table.pid IN ($pidList)".$this->cObj->enableFields($cat_table)."\n";
		return $query;
	}


##	/*
##	*	All events at a glance
##	*/
##
##	function displayQuickview() {
##		$lConf = $this -> conf["displayQuickview."];
##		$template = $this->loadTemplate("###TEMPLATE_QUICKVIEW###");
##		$subpartArray = array();
##		$wrappedSubpartArray = array();
##		$markerArray = array();
##
##		$cm = intval(date("n"));
##		$today = mktime(0, 0, 0, $cm, date("j"), date("Y"));
##		$cm = $cm > 1 ? $cm -1 : 12;
##		$end = $today + (intval($lConf['limit']) * 86400);
##		$markerArray["###DAYS_AHEAD###"] = $lConf['limit'];
##		$where = " date >= $today AND date <= $end ";
##		$selectConf = $this -> getSelectConf($where);
##		$query = $this -> cObj -> getQuery($this -> calendarTable, $selectConf);
##		$res = mysql(TYPO3_db, $query);
##		if (mysql_num_rows($res) < 1) {
##			return $this -> cObj -> substituteMarkerArrayCached($template, array(), $subpartArray, $wrappedSubpartArray)."<br><br><p>".$lConf['noEventsMsg']."</p>";
##		}
##		echo mysql_error();
##		$dtemplate = $this->loadTemplate("###QUICKVIEW_DATE###");
##
##		$mtemplate = $this ->loadTemplate("###QUICKVIEW_MONTH###");
##		$dsubpartArray = array();
##		$dmarkerArray = array();
##		while ($row = mysql_fetch_assoc($res)) {
##			if (intval(date("n", $row['date'])) <> $cm) {
##				$mmarkerArray["###QUICKVIEW_MONTH_NAME###"] = ucfirst(strftime("%B %Y", $row['date']));
##				$subpartArray["###CONTENT###"].= $this -> cObj -> substituteMarkerArrayCached($mtemplate, $mmarkerArray, array(), array());
##			}
##			$dmarkerArray["###DATE###"] = ucfirst(strftime("%a %e", $row['date']));
##			if ($row['date'] <> $row['tx_advCalendar_enddate'] && intval($row['tx_advCalendar_enddate']) <> 0) {
##				$dmarkerArray["###DATE###"].= " - ".ucfirst(strftime("%a %e", $row['tx_advCalendar_enddate']));
##			}
##			$dwrappedSubpartArray["###EVENT_LINK###"] = array("<A href='".$this -> pi_linkTP_keepPIvars_url(array("view" => CALENDAR_VIEW_EVENT, "eventid" => $row['uid']))."'>", "</A>");
##			$dmarkerArray["###TIME###"] = strftime("%H:%M", intval($row['time']) + intval($row['date']));
##			$dmarkerArray["###TITLE###"] = $row['title'];
##			$subpartArray["###CONTENT###"].= $this -> cObj -> substituteMarkerArrayCached($dtemplate, $dmarkerArray, array(), $dwrappedSubpartArray);
##			$cm = intval(date("n", $row['date']));
##		}
##		$content = $this -> cObj -> substituteMarkerArrayCached($template, $markerArray, $subpartArray, $wrappedSubpartArray);
##		return $content;
##	}
##

	/**
	 * get common wrappedSubpartArrays, such as LINK_CURRENT_MONTH
	 */
	function getCommonMarkerArray($lConf) {
		$markerArray = array();
		$subpartArray = array();
		$wrappedSubpartArray = array();


		/* Switch the view, but keep the date */
		$wrappedSubpartArray["###LINK_SWITCH_TO_MONTH###"] = $this->createLinkWrap(
				$this->pi_linkTP_keepPIvars_url(array("view" => CALENDAR_VIEW_MONTH), $this->allowCaching));
		$wrappedSubpartArray["###LINK_SWITCH_TO_WEEK###"] = $this->createLinkWrap( 
				$this->pi_linkTP_keepPIvars_url(array("view" => CALENDAR_VIEW_WEEK), $this->allowCaching));
		$wrappedSubpartArray["###LINK_SWITCH_TO_DAY###"] = $this->createLinkWrap( 
				$this->pi_linkTP_keepPIvars_url(array("view" => CALENDAR_VIEW_DAY), $this->allowCaching));
		$wrappedSubpartArray["###LINK_SWITCH_TO_OVERVIEW###"] = $this->createLinkWrap( 
				$this->pi_linkTP_keepPIvars_url(array("view" => CALENDAR_VIEW_QUICK), $this->allowCaching));

		/* Switch the date, but keep the view */
		$newvars = array("viewtime" => $this->getTodayTime());
		$wrappedSubpartArray["###LINK_TODAY###"]= $this->createLinkWrap($this->pi_linkTP_keepPIvars_url($newvars, $this->allowCaching));
		$tmstmp = mktime(0, 0, 0, $this->getCurrentMonth(), 1, $this->getCurrentYear());
		$markerArray["###CURRENT_MONTH###"]= $this->formatStr($this->cObj->stdWrap($tmstmp, $lConf['currentMonthWrap.']));
		$markerArray["###PREV_MONTH###"]= $this->formatStr($this->cObj->stdWrap($this->getPrevMonthTime(), $lConf['prevMonthWrap.']));
		$markerArray["###NEXT_MONTH###"]= $this->formatStr($this->cObj->stdWrap($this->getNextMonthTime(), $lConf['nextMonthWrap.']));
		$markerArray["###PREV_YEAR###"]= $this->formatStr($this->cObj->stdWrap($this->getPrevYearTime(), $lConf['prevYearWrap.']));
		$markerArray["###NEXT_YEAR###"]= $this->formatStr($this->cObj->stdWrap($this->getNextYearTime(), $lConf['nextYearWrap.']));
		$markerArray["###PREV_DAY###"] = $this->formatStr($this->cObj->stdWrap($this->getTime() - 86400, $lConf['prevDayWrap.']));
		$markerArray["###NEXT_DAY###"] = $this->formatStr($this->cObj->stdWrap($this->getTime() + 86400, $lConf['nextDayWrap.']));
		
		// Hmm, I'd really like to wrap the link into a typolinkWrap, but there is no way to keep the PIvars, so do it directly

		$newvars = array("viewtime" => $this->getTime() - 86400);
		$wrappedSubpartArray["###LINK_PREV_DAY###"]= $this->createLinkWrap($this->pi_linkTP_keepPIvars_url($newvars, $this->allowCaching));
		$newvars = array("viewtime" => $this->getTime() + 86400);
		$wrappedSubpartArray["###LINK_NEXT_DAY###"]= $this->createLinkWrap($this->pi_linkTP_keepPIvars_url($newvars, $this->allowCaching));
		$newvars = array("viewtime" => $this->getPrevMonthTime());
		$wrappedSubpartArray["###LINK_PREV_MONTH###"]= $this->createLinkWrap($this->pi_linkTP_keepPIvars_url($newvars, $this->allowCaching));
		$newvars = array("viewtime" => $this->getNextMonthTime());
		$wrappedSubpartArray["###LINK_NEXT_MONTH###"]= $this->createLinkWrap($this->pi_linkTP_keepPIvars_url($newvars, $this->allowCaching));
		$newvars = array("viewtime" => $this->getPrevYearTime());
		$wrappedSubpartArray["###LINK_PREV_YEAR###"]= $this->createLinkWrap($this->pi_linkTP_keepPIvars_url($newvars, $this->allowCaching));
		$newvars = array("viewtime" => $this->getNextYearTime());
		$wrappedSubpartArray["###LINK_NEXT_YEAR###"]= $this->createLinkWrap($this->pi_linkTP_keepPIvars_url($newvars, $this->allowCaching));




##		//get the next 6 months
##		for ($i = 0, $nextmonth = $timestamp; $i < 7; $i ++, $nextmonth += 2678400) {
##			print "warning: direct printf!";
##			$markerArray["###MONTH_STR_+".$i."###"] = ucfirst(strftime($conf, $nextmonth));
##			$markerArray["###MONTH_URL_+".$i."###"] = $this -> pi_linkTP_keepPIvars_url(array("month" => date("n", $nextmonth), "year" => date("Y", $nextmonth)));
##		}
##		//get the previous 6 months
##		for ($i = 1, $prevmonth = $timestamp -2419200; $i < 7; $i ++, $prevmonth -= 2419200) {
##			print "hier direktes strftime";
##			$markerArray["###MONTH_STR_-".$i."###"] = ucfirst(strftime($conf, $prevmonth));
##			$markerArray["###MONTH_URL_-".$i."###"] = $this -> pi_linkTP_keepPIvars_url(array("month" => date("n", $prevmonth), "year" => date("Y", $prevmonth)));
##		}




		$displayCategorySelect = intval($lConf['displayCategorySelect']);
		# $markerArray["###CATEGORY_SELECT###"] = $displayCategorySelect ? $this -> makeCategorySelect(2, $this -> getCurrentCategory()) : "";


		
		return array($markerArray, $subpartArray, $wrappedSubpartArray);
	}

	/**
	 * requires $this->internal[currenRow] to be set
	 */
	function getMarkerArrayEventWise(&$markerArray, &$subpartArray, &$wrappedSubpartArray, $lConf) {
		$markerArray["###TITLE###"] = $this->pi_getEditIcon($this->formatStr($this->getFieldContent("title", $lConf)), "");
		$markerArray["###TEASER###"] = $this->pi_getEditIcon($this->formatStr($this->getFieldContent("teaser", $lConf)), "");
		$markerArray["###DESCRIPTION###"] = $this->formatStr($this->getFieldContent("descr", $lConf));

		$markerArray["###STARTDATE###"] = $this->formatStr($this->getFieldContent("start_date", $lConf));
		$markerArray["###STARTTIME###"] = $this->formatStr($this->getFieldContent("start_time", $lConf));
		$markerArray["###ENDDATE###"] = $this->formatStr($this->getFieldContent("end_date", $lConf));
		$markerArray["###ENDTIME###"] = $this->formatStr($this->getFieldContent("end_time", $lConf));

		$markerArray["###PLACE###"] = $this->formatStr($this->getFieldContent("place", $lConf));
		$markerArray["###ADDRESS###"] = $this->formatStr($this->getFieldContent("address", $lConf));
		$markerArray["###ORGANIZER###"] = $this->formatStr($this->getFieldContent("organizer", $lConf));
		$markerArray["###ORGANIZER_EMAIL###"] = $this->formatStr($this->getFieldContent("organizer_email", $lConf));
		$markerArray["###MOREINFO###"] = $this->formatStr($this ->getFieldContent("moreinfo", $lConf));
		$markerArray["###URL###"] = $this->formatStr($this ->getFieldContent("url", $lConf));
		$markerArray["###IMAGE###"] = $this->getFieldContent("image", $lConf);

		$markerArray["###CATEGORY###"] = $this->formatStr($this ->getFieldContent("category", $lConf));
		$markerArray["###CATEGORY_IMAGE###"] = $this->getFieldContent("category_image", $lConf);
	}

	function getMarkerArrayEvent() {
		$lConf = $this -> conf["displayEvent."];
		
		list($markerArray, $subpartArray, $wrappedSubpartArray) = $this->getCommonMarkerArray($lConf);

		$this->getMarkerArrayEventWise($markerArray, $subpartArray, $wrappedSubpartArray, $lConf);
		
		return array($markerArray, $subpartArray, $wrappedSubpartArray);
	}
	
	function displayEvent($content, $conf) {
		$this->internal["currentRow"] = $this->pi_getRecord($this->dbTable, intval($this->piVars["showUid"]));

		// This sets the title of the page for use in indexed search results:
		if ($this->internal["currentRow"]["title"])
			$GLOBALS["TSFE"]->indexedDocTitle = $this->internal["currentRow"]["title"];
				
		$template = $this->loadTemplate("###TEMPLATE_EVENT###");
		list($markerArray, $subpartArray, $wrappedSubpartArray) = $this->getMarkerArrayEvent();
		$content.= $this->cObj->substituteMarkerArrayCached($template, $markerArray, $subpartArray, $wrappedSubpartArray);

		return $content;
	}

	function getMarkerArrayDay() {
		$lConf = $this -> conf["displayDay."];
		list($markerArray, $subpartArray, $wrappedSubpartArray) = $this->getCommonMarkerArray($lConf);

		$markerArray["###DAY###"] = $this->formatStr($this->cObj->stdWrap($this->getTime(), $lConf['dayTitleWrap.']));

		return array($markerArray, $subpartArray, $wrappedSubpartArray);
	}
	
	function displayDay() {
		$lConf = $this -> conf["displayDay."];
		list ($markerArray, $subpartArray, $wrappedSubpartArray) = $this->getMarkerArrayDay($lConf); 
		$template = $this ->loadTemplate("###TEMPLATE_DAY###");
		$tmstmp = $this->getTime();
		$nextd = $tmstmp +86400;
		$prevd = $tmstmp -86400;
		$daytable = "";
		
		// save how many events we have shown per line already
		$matrix = array();
		for ($x = 0; $x < 24; $x++) {
			$matrix[$x] = 0;
		}
		$maxcols = 1;

		$lines = array();
		for ($lb = $tmstmp, $ub = $tmstmp + 3600, $i = 0; $i < 24; $i++, $ub += 3600, $lb += 3600) {
			$lines[$i] = "";
			$lines[$i] .= $this->formatStr($this->cObj->stdWrap($lb, $lConf['hourHeaderWrap.']));

			// if beginning of day, get elements lasting to this date as well
			if ($i == 0)
				$addWhere = "(	start_date + start_time < $lb AND
						end_date + end_time > $lb AND
						(start_date = $tmstmp OR end_date = $tmstmp)
					)";
			else
				$addWhere = "1=0";

			//get events starting in this time interval
			$where = "($addWhere OR (start_date + start_time >= $lb AND start_date + start_time < $ub AND start_time != 0))";
			$query = $this->cObj->getQuery($this->dbTable, $this->getSelectConf($where));
			$res = mysql(TYPO3_db, $query);
			if (mysql_errno())
				print mysql_error();
			while ($row = mysql_fetch_assoc($res)) {
				$this->internal["currentRow"] = $row;
				//adding a td element for each event starting in this time interval
				$rowspan = 1;

				// If this doesn't have an end-date specified, set it to the start's day
				if (intval($row['end_date']) == 0)
					$row['end_date'] = intval($row['start_date']);
				// If this doesn't have an end-time, or end_date is not today, let it last to the days' end
				if (intval($row['end_time']) == 0 || $row['end_date'] != $tmstmp)
					$row['end_time'] = 24 * 3600;

				// now calculate how many rows we need to span
				$rowspan = ceil(intval($row['end_time']) / 3600) - $i;

				// save in Matrix how many events shown
				for ($x = $i; $x <= $i + $rowspan - 1; $x++) {
					$matrix[$x]++;
					if ($matrix[$x] > $maxcols)
						$maxcols = $matrix[$x];
				}
				$temp = $this->cObj->stdWrap(
					$this->pi_linkTP_keepPIvars($this->formatStr($this->getFieldContent('title', $lConf)), array(
						"showUid" => $row['uid'],
						"view" => CALENDAR_VIEW_EVENT,
						), $this->allowCaching),
					$lConf['singleEventWrap.']);
				$temp = str_replace("###rowspan###", "$rowspan", $temp);
				$lines[$i] .= $temp;
			}

		}

		// first we need to display events lasting the whole day or more than one day
		// a bit indented to make it clearer ;-)
		$where = "(
				-- spanning whole day: no start_time
				start_date = $tmstmp AND start_time = 0
			OR
				-- spanning whole day: no end time
				start_date < $tmstmp AND end_date >= $tmstmp AND end_time = 0
			) ";

		$query = $this->cObj->getQuery($this->dbTable, $this->getSelectConf($where));
		$res = mysql(TYPO3_db, $query);

		$fullDayEvents = "";
		while ($row = mysql_fetch_assoc($res)) {
			$this->internal["currentRow"] = $row;
			// XXX want to use pi_list_linkSingle, but they removed the urlOnly flag :-(
			$line = $this->cObj->stdWrap('<A href="'.
					$this->pi_linkTP_keepPIvars_url(array("view" => CALENDAR_VIEW_EVENT, "showUid" => $row['uid']),
						$this->allowCaching).
					'">' .
					$this->formatStr($this->getFieldContent('title', $lConf)) .
					"</A>",
				$lConf['fullDayEventWrap.']);

			$fullDayEvents .= str_replace("###colspan###", "$maxcols", $line);
			
		}
		$temp = $this->cObj->stdWrap($fullDayEvents, $lConf['fullDayAllEventsWrap.']);
		$daytable .= str_replace("###colspan###", "$maxcols", $temp);

		// now display each hour
		for ($i = 0; $i < 24; $i++) {
			for ($x = $matrix[$i]; $x < $maxcols; $x++) 
				$lines[$i] .= $this->cObj->stdWrap($this->formatStr(""), $lConf['emptyEventWrap.']);
			$daytable.= $this->cObj->stdWrap($lines[$i], $lConf[($i % 2) ? 'hourLineOddWrap.' : 'hourLineEvenWrap.']);
		}

		$markerArray["###DAYTABLE###"] = $this->cObj->stdWrap($daytable, $lConf['dayTableWrap.']);
		$content.= $this->cObj->substituteMarkerArrayCached($template, $markerArray, $subpartArray, $wrappedSubpartArray);

		return $content;
	}

##
##	/*
##	*	week view
##	*
##	*/
##
##	function displayWeek() {
##		$week = $this -> getCurrentWeek();
##		$year = $this -> getCurrentYear();
##		$start = $this -> fDOWtimestamp($week, $year); //timestamp first day (monday) in week
##		$start = mktime(0, 0, 0, date("n", $start), date("j", $start), date("Y", $start));
##		$pw = $start -604800;
##		$nw = $start +604800;
##		$layout1 = "###DAY1###";
##		$layout2 = "###DAY2###";
##		$template = $this->loadTemplate("###TEMPLATE_WEEK###");
##		$markerArray = array();
##		$wrappedSubpartArray = array();
##		$subpartArray = array();
##		$wrappedSubpartArray["###LINK_CURRENT_MONTH###"] = array("<A href='".$this -> getLinkUrl(1)."'>", "</A>");
##		$wrappedSubpartArray["###LINK_CURRENT_WEEK###"] = array("<A href='".$this -> getLinkUrl(2)."'>", "</A>");
##		$wrappedSubpartArray["###LINK_CURRENT_DAY###"] = array("<A href='".$this -> getLinkUrl(3)."'>", "</A>");
##		$wrappedSubpartArray["###LINK_OVERVIEW###"] = array("<A href='".$this -> getLinkUrl(5)."'>", "</A>");
##		$wrappedSubpartArray["###LINK_PREV_WEEK###"] = array("<A href='".$this -> getLinkUrl(2, "", "", date("Y", $pw), date("W", $pw))."'>", "</A>");
##		$wrappedSubpartArray["###LINK_NEXT_WEEK###"] = array("<A href='".$this -> getLinkUrl(2, "", "", date("Y", $nw), date("W", $nw))."'>", "</A>");
##		$markerArray["###NUM_PREV_WEEK###"] = $week > 2 ? $week -1 : 52;
##		$markerArray["###NUM_NEXT_WEEK###"] = $week < 52 ? $week +1 : 1;
##		$markerArray["###NUM_CURRENT_WEEK###"] = $week < 53 ? $week : 52;
##		$markerArray["###YEAR_CURRENT_WEEK###"] = $year;
##
##		for ($i = 0, $d = $start, $layout = $layout1; $i < 7; $i ++, $d += 86400) {
##			$daytemplate = $this->loadTemplate($layout);
##			$wrappedSubpartArray2 = array();
##			$markerArray2 = array();
##			$subpartArray2 = array();
##			$wrappedSubpartArray2["###DAY_LINK###"] = array("<A href='".$this -> getLinkUrl(3, date("n", $d), date("j", $d), date("Y", $d))."'>", "</A>");
##			$markerArray2["###DAY_NUM###"] = date("j", $d);
##			setlocale(LC_ALL, "de_DE.ISO8859-1");
##			$markerArray2["###DAYNAME###"] = ucfirst(strftime("%A", $d));
##			//getting events
##			$where = " (date = $d OR (date < $d AND tx_advCalendar_enddate >= $d)) ";
##			//filter if private calendar
##			$where.= $this -> addFilter();
##			$query = $this -> cObj -> getQuery($this -> calendarTable, $this -> getSelectConf($where));
##			$res = mysql(TYPO3_db, $query);
##			echo mysql_error();
##
##			while ($row = mysql_fetch_assoc($res)) {
##				$eventtemplate = $this->loadTemplage("###EVENT###");
##				$wrappedSubpartArray3 = array();
##				$markerArray3 = array();
##				$wrappedSubpartArray3["###EVENT_LINK###"] = array("<A href='".$this -> getLinkUrl(4, "", "", "", "", $row['uid'])."'>", "</A>");
##				$markerArray3["###TIME###"] = strftime("%H:%M", intval($row['time']) + intval($row['date']));
##				$markerArray3["###TITLE###"] = $row['title'];
##				$subpartArray2["###EVENT_LIST###"].= $this -> cObj -> substituteMarkerArrayCached($eventtemplate, $markerArray3, array(), $wrappedSubpartArray3);
##			}
##			$subpartArray2["###EVENT_LIST###"].= "&nbsp;";
##			$subpartArray["###CONTENT###"].= $this -> cObj -> substituteMarkerArrayCached($daytemplate, $markerArray2, $subpartArray2, $wrappedSubpartArray2);
##			$layout = $layout == $layout1 ? $layout2 : $layout1;
##		}
##
##		$content.= $this -> cObj -> substituteMarkerArrayCached($template, $markerArray, $subpartArray, $wrappedSubpartArray);
##
##		return $content;
##	}
##




	function getMarkerArrayMonth() {
		$lConf = $this -> conf["displayMonth."];
		list($markerArray, $subpartArray, $wrappedSubpartArray) = $this->getCommonMarkerArray($lConf);
		return array($markerArray, $subpartArray, $wrappedSubpartArray);
	}
	function displayMonth()	{
		$lConf = $this->conf["displayMonth."];
		$template = $this->loadTemplate("###TEMPLATE_MONTH###");

		list($markerArray, $subpartArray, $wrappedSubpartArray) = $this->getMarkerArrayMonth();

		$month = $this->getCurrentMonth();
		$year = $this->getCurrentYear();
		
		// Display Options
		$displayEvents = intval($lConf['displayEvents']);
		$displayWeekNumbers = intval($lConf['displayWeekNumbers']);
		$displayDayNames = intval($lConf['displayWeekDayNames']);


		// get the day where the month begins
		$monthBegin = $this->getMonthBeginTime();

		// now we need to get the day of the first week in this month
		$daySeconds = 3600 * 24;
		$dayOfWeek = $this->getDayOfTheWeek($monthBegin);
		$firstWeekToDisplay = $monthBegin - ($dayOfWeek-1) * $daySeconds;

		/* Create the Matrix - week-wise */
		$calstr = "";

		/* First the header column */
		$weekDayNames = $this->cObj->stdWrap("", $lConf['weekDayNamesWeekNumWrap.']);
		for ($i = 0; $i < 7; $i++) {
			$weekDayNames .= $this->cObj->stdWrap($firstWeekToDisplay + $i * $daySeconds, $lConf['weekDayNamesWrap.']);
		}
		$calstr .= $this->cObj->stdWrap($weekDayNames, $lConf['weekDayNamesLineWrap.']);

		/* now week-wise the days */
		$currentDay = $firstWeekToDisplay;
		while (date("Ym", $currentDay) <= date("Ym", $this->getTime())) {
			$daystr = "";
			$eventstr = "";

			$daystr .= $this->cObj->stdWrap($currentDay, $lConf['weekNumHeaderWrap.']);			
			if ($displayEvents) {
				$eventstr.= $this->cObj->stdWrap("", $lConf['weekNumEventWrap.']);
			}

			for ($day = 0; $day < 7; $day++) {
				if (date("n", $currentDay) != date("n", $this->getTime())) {
					$theDayWrap = 'daysHeaderNotInMonthWrap.';
					$theEventWrap = 'eventsNotInMonthWrap.';
				} else if (date("dnY", $currentDay) == date("dnY")) {
					$theDayWrap = 'daysHeaderCurrentDayWrap.';
					$theEventWrap = 'eventsCurrentDayWrap.';
				} else {
					$theDayWrap = 'daysHeaderStandardWrap.';
					$theEventWrap = 'eventsStandardWrap.';
				}

				$theDay = $this->cObj->stdWrap($currentDay, $lConf['daysHeaderWrap.']);
				$link = $this->pi_linkTP_keepPIvars($theDay,
					array("view" => CALENDAR_VIEW_DAY, "viewtime" => $currentDay),
					$this->allowCaching);
				$daystr .= $this->cObj->stdWrap($link, $lConf[$theDayWrap]);

				// in case we shall display the events, fetch all events of that day
				if ($displayEvents) {
					// construct the SQL-WHERE to fetch only events on this date or spanning to this date
					// 030829 thx to ENUNEZ
					$where = ' (start_date = '.$currentDay.
						' OR (start_date < '.$currentDay.' AND end_date + '.$daySeconds.' > '.$currentDay.')) ';
					
					//filter for category
					#if ($this->getCurrentCategory() > 0) {
					#	$where.= 'AND (' . $this->getCurrentCategory . ' IN category) ';
					#}

					$query = $this->cObj->getQuery($this->dbTable, $this->getSelectConf($where));
					$res = mysql(TYPO3_db, $query);

					$evno = 1;
					$todaysevents = "";
					while ($row = mysql_fetch_assoc($res)) {
						$this->internal["currentRow"] = $row;
						if ($evno > 1)
							$todaysevents .= $this->cObj->stdWrap("", $lConf['eventsDelimWrap.']);

						$link = $this->pi_linkTP_keepPIvars(
							$this->getFieldContent('title', $lConf),
							array("view" => CALENDAR_VIEW_EVENT,
								"showUid" => $row['uid'],
								"viewtime" => $currentDay,
							),
							$this->allowCaching);
						$todaysevents .= $this->cObj->stdWrap($link, $lConf['singleEventStandardWrap.']);

						$evno ++;
					}
					$eventstr .= $this->cObj->stdWrap(($todaysevents ? $todaysevents : "&nbsp;"), $lConf[$theEventWrap]);
				}

				$currentDay += $daySeconds;
			}


			$calstr .= $this->cObj->stdWrap($daystr, $lConf['weekLineDaysWrap.']);
			if ($displayEvents)
				$calstr .= $this->cObj->stdWrap($eventstr, $lConf['weekLineEventsWrap.']);

		}

		$markerArray["###CALENDAR_MATRIX###"] = $this->cObj->stdWrap($calstr, $lConf['calendarMatrixWrap.']);


##		//GASTAN
##		//render list of event in currently displayed month
##		$listEventsAtBottom = intval($lConf['listEventsAtBottom']);
##
##		$events = "";
##		if ($listEventsAtBottom) {
##			//render event's list at the bottom of the calendar
##			//echo "firstDayInMonth:" . strftime("%d.%m.%Y", $firstDayInMonth) . "<br>lastDayInMonth:" . strftime("%d.%m.%Y", $lastDayInMonth) . "<br>";
##			$where = " (date >= " . $this->getMonthBeginTime() ." AND date <= " . $this->getMonthEndTime() . ") ";
##			//filter for category
##			if ($displayCategorySelect && $this -> piVars["category"] > 0) {
##				$where.= "AND (category = ".$this -> piVars["category"].") ";
##			}
##			//filter if private calendar
##			$where.= $this -> addFilter();
##			$query = $this -> cObj -> getQuery($this -> calendarTable, $this -> getSelectConf($where));
##			//echo "query:$query<br>";
##			$res = mysql(TYPO3_db, $query);
##			echo mysql_error();
##			$evno = 1;
##			//echo "this->conf['generalDateFormat']:" . $this->conf['generalDateFormat'];
##			while ($row = mysql_fetch_assoc($res)) {
##				$linkStr = "<A href='";
##				$linkStr.= $this -> pi_linkTP_keepPIvars_url(array("view" => CALENDAR_VIEW_EVENT, "showUid" => $row['uid']));
##				$linkStr.= "' title=\"".$row['title']."\">".strftime($this -> conf['generalDateFormat'], $row['date'])." - ".$row['title']."</A>";
##				//echo "date:" . $row['date'] . "<br>";
##				//echo "date(row['date'])" . date("Ynd",$row['date']) . "<br>";
##				//echo "date(dnY,mktime())" . date("Ynd",mktime())  . "<br>";
##				if (date("Ynd", $row['date']) <= date("Ynd", mktime()))
##					$events.= $this -> cObj -> stdWrap($linkStr, $lConf['bottomEventsExpiredWrap.']);
##				else
##					$events.= $this -> cObj -> stdWrap($linkStr, $lConf['bottomEventsWrap.']);
##				$evno ++;
##			}
##			$evno = 1;
##			//echo "events:$events<br>";
##			$markerArray["###LIST_EVENTS_MATRIX###"] = $events;
##		}

		$content .= $this ->cObj->substituteMarkerArrayCached($template, $markerArray,array(),$wrappedSubpartArray);

		return $content;
	}

	function getFieldContent($fN, $lConf)   {
		switch($fN) {
			case "uid":
				return $this->pi_list_linkSingle($this->internal["currentRow"][$fN],
					$this->internal["currentRow"]["uid"], $this->allowCaching);
				break;
			case "title":
				return $this->cObj->stdWrap($this->internal["currentRow"]["title"], $lConf['eventTitleWrap.']);
			case "descr":
				return $this->cObj->stdWrap($this->pi_RTEcssText($this->internal["currentRow"]["descr"]), $lConf['eventDescrWrap.']);
			case "start_date":
				return $this->cObj->stdWrap($this->internal["currentRow"]["start_date"], $lConf["eventStartDateWrap."]);
			case "start_time":
				$value = $this->internal['currentRow']['start_time'];
				$value = ($value ? $value + $this->internal['currentRow']['start_date'] : '');
				return $this->cObj->stdWrap($value, $lConf["eventStartTimeWrap."]);
			case "end_date":
				$value = $this->internal['currentRow']['end_date'];
				$value = ($value ? $value : '');
				return $this->cObj->stdWrap($value, $lConf["eventEndDateWrap."]);
			case "end_time":
				$value = $this->internal['currentRow']['end_time'];
				if ($value) {
					$value = ($this->internal['currentRow']['end_date'] ?
						$value + $this->internal['currentRow']['end_date'] :
						$value + $this->internal['currentRow']['start_date']);
				} else {
					$value = '';
				}
				return $this->cObj->stdWrap($value, $lConf["eventEndTimeWrap."]);
			case "organizer":
				return $this->cObj->stdWrap($this->internal["currentRow"]['organizer'], $lConf["eventOrganizerWrap."]);
			case "organizer_email":
				return $this->cObj->stdWrap($this->internal["currentRow"]['organizer_email'], $lConf["eventOrganizerEmailWrap."]);
			case "place":
				return $this->cObj->stdWrap($this->internal["currentRow"]['place'], $lConf["eventPlaceWrap."]);
			case "address":
				return $this->cObj->stdWrap(nl2br($this->internal["currentRow"]['address']), $lConf["eventAddressWrap."]);
			case "moreinfo":
				return $this->cObj->stdWrap($this->pi_RTEcssText($this->internal["currentRow"]['moreinfo']), $lConf["eventMoreInfoWrap."]);
			case "category":
				return $this->cObj->stdWrap($this->categories[$this->internal['currentRow']['category']]['title'], $lConf["eventCategoryWrap."]);
			case "category_image":
				$img = $lConf['eventCategoryImage.'];
				$img['file'] = 'uploads/tx_calendar/' . $this->categories[$this->internal['currentRow']['category']]['image'];
				return $this->cObj->IMAGE($img);

			case "url":
				$url = $lConf['eventUrl.'];
				$url['parameter'] = $this->internal['currentRow']['url'];
				$text = $this->internal['currentRow']['url_text'];
				if ($text) {
					$text = $this->formatStr($this->cObj->stdWrap($text, $lConf['eventUrlTitleWrap.']));
				} else {
					$text = $this->cObj->typoLink_URL($url);
				}
				return $this->cObj->typolink($text, $url);
			case "image":
				$img = $lConf['eventImage.'];
				$img['file'] = 'uploads/tx_calendar/' . $this->internal['currentRow']['image'];
				return $this->cObj->IMAGE($img);

                
            default:
                return $this->internal["currentRow"][$fN];
                break;
            }
        }


	


	function loadTemplate($theSubpart) {
		if ($this->templateCode == null)
				$this->templateCode = $this->cObj->fileResource($this->conf["templateFile"]);
		if ($this -> templateCode == "") {
			return '<h3>' . $this->extKey . ': no template file found:'.$this -> conf["templateFile"] . '</h3>';
		}
		return $this->cObj->getSubpart($this->templateCode, $theSubpart);
	}


	function getSelectConf($where) {
		//get events
		$selectConf = Array();
		$selectConf["pidInList"] = $this -> pid_list;
		$selectConf["where"] = $where;
		$selectConf["orderBy"] = "start_date, start_time";
		return $selectConf;
	}


##	/**
##	 * Make the selectorbox with categories.
##	 * mode = 
##	 * 1 - Select category in adding/edditing record
##	 * 2 - Select Category for filtering
##	 */
##	function makeCategorySelect($mode = 1, $selCat = "") {
##		$this -> loadCategories();
##		$opt = array();
##
##		if ($mode == 1)
##			$value = $this -> conf['defaultCategory'].$extra;
##		elseif ($mode == 2) $value = htmlentities($this -> pi_linkTP_keepPIvars_url(array("category" => "")));
##
##		/* Suck in label for "allCategories" from typoscript */
##		if ($mode == 2 && $this -> conf["allCategories"])
##			$opt[] = '<option value="'.$value.'">'.$this -> conf["allCategories"].'</option>';
##		else
##			$opt[] = '<option value="'.$value.'">'.$this -> pi_getLL('Category_Select'.$mode).'</option>';
##
##		while (list ($k, $v) = each($this -> categories)) {
##			if ($mode == 1)
##				$opt[] = '<option value="'.htmlentities($k).'"'. ($selCat == $k ? " SELECTED" : "").'>'.htmlentities($v).'</option>';
##			elseif ($mode == 2) $opt[] = '<option value="'.htmlentities($this -> pi_linkTP_keepPIvars_url(array("category" => $k))).'"'. ($selCat == $k ? " SELECTED" : "").'>'.htmlentities($v).'</option>';
##		}
##		if ($mode == 1)
##			return '<select name="FE[tt_calender][category]" >'.implode("", $opt).'</select>';
##		elseif ($mode == 2) return '<select onChange="document.location=this.options[this.selectedIndex].value;">'.implode("", $opt).'</select>';
##	}
##


	/* -------------- small helper functions ----------------- */

	/**
	 * before displaying content, wrap everthing through general_stdWrap
	 */
	function formatStr($str)        {
		if (is_array($this->conf["general_stdWrap."]))  {
			$str = $this->cObj->stdWrap($str,$this->conf["general_stdWrap."]);
		}
		return $str;
	}

	/**
	 * put the given link in an array of anchor tags, for use with subpartArrays
	 */
	function createLinkWrap($theLink) {
		return array('<a href="' . $theLink . '">', '</a>');
	}


	/**
	 * Return seconds from 00:00 of a given date. XXX unused
	 * @param integer Unix timestamp
	 */
	function timestamp($res) {
		return 3600 * strftime("%H", $res) + 60 * strftime("%M", $res);
	}

	function setCurrentCategory($theValue) {
		$this->piVars["category"] = intval($theValue);
	}
	function getCurrentCategory() {
		return intval($this->piVars["category"]);
	}

	function setTime($theValue) {
		$this->piVars["viewtime"] = intval($theValue);
	}
	function getTime() {
		return intval($this->piVars["viewtime"]);
	}
	function getTodayTime() {
		return mktime(0, 0, 0, date('n'), date('j'), date('Y'));
	}

	function getCurrentDay() {
		return date('d', $this->getTime());
	}
	function getCurrentMonth() {
		return date('n', $this->getTime());
	}
	function getCurrentYear() {
		return date('Y', $this->getTime());
	}
	function getCurrentWeek() {
		return date('W', $this->getTime());
	}

	function getPrevMonthTime() {
		return mktime(0,0,0, $this->getPrevMonthMonth(), $this->getCurrentDay(), $this->getPrevMonthYear());
	}
	function getNextMonthTime() {
		return mktime(0,0,0, $this->getNextMonthMonth(), $this->getCurrentDay(), $this->getNextMonthYear());
	}
	function getPrevYearTime() {
		return mktime(0,0,0, $this->getCurrentMonth(), $this->getCurrentDay(), $this->getPrevYear());
	}
	function getNextYearTime() {
		return mktime(0,0,0, $this->getCurrentMonth(), $this->getCurrentDay(), $this->getNextYear());
	}

	/**
	 * return previous month
	 */
	function getPrevMonthMonth() {
		$month = $this->getCurrentMonth();
		return $month > 1 ? $month -1 : 12;
	}
	/**
	 * return previous month's year
	 */
	function getPrevMonthYear() {
		$year = $this->getCurrentYear();
		return $this->getCurrentMonth() > 1 ? $year : $year -1;
	}
	/**
	 * return next month
	 */
	function getNextMonthMonth() {
		$month = $this->getCurrentMonth();
		return $month < 12 ? $month +1 : 1;
	}
	/**
	 * return next month's year
	 */
	function getNextMonthYear() {
		$year = $this->getCurrentYear();
		return $this->getCurrentMonth() < 12 ? $year : $year +1;
	}
	/**
	 * return previous year
	 */
	function getPrevYear() {
		return $this->getCurrentYear() - 1;
	}
	/**
	 * return next year
	 */
	function getNextYear() {
		return $this->getCurrentYear() + 1;
	}
	
	/**
	 * get last day in month
	 */
	function getLastDayInMonth($theTime) {
		return date('t', $theTime);
	}
	
	/**
	 * return tmstmp of first second in this month
	 */
	function getMonthBeginTime() {
		return mktime(0, 0, 0, $this->getCurrentMonth(), 1, $this->getCurrentYear());
	}
	/**
	 * return tmstmp of last second in this month
	 */
	function getMonthEndTime() {
		return mktime(23, 59, 59, $this->getCurrentMonth(), $this->getLastDayInMonth(), $this->getCurrentYear());
	}

	function getDayOfTheWeek($theTime) {
		return date("w", $theTime);
	}
	function getWeekOfTheYear($theTime) {
		return date("W", $theTime);
	}


	function setCurrentView($theValue) {
		$this->piVars["view"] = intval($theValue);
	}
	function getCurrentView() {
		return intval($this->piVars["view"]);
	}

	/**
	 * Sets the pid_list internal var
	 */
	function setPidlist($pid_list) {
		$this->pid_list = $pid_list;
	}
	function getPidlist() {
		return $this->pid_list;
	}
}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/calendar/pi1/class.tx_calendar_pi1.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/calendar/pi1/class.tx_calendar_pi1.php"]);
}

?>
